#define	__ASSEMBLY__
#include <note.h>
#include <MiXen.h>

#include <machine/param.h>

	.text
	.globl	_start
_start:
	cld
	movq	%rsi,%rdi
	call	main
1:
	call	halt
	jmp	1b

#
# void switchstack(void *p)
# Switch to a new stack.  Both old and new stack are considered to be
# exactly one page.  The argument p is the top of the stack
# aka the end of the page.  Note that any pointers pointing into the
# stack (incl. frame pointers) are NOT translated!
#
	.globl	switchstack
switchstack:
	popq	%rdx
	movq	%rsp,%rsi
	movq	%rsi,%rax
	andq	$0xfff,%rax
	movq	$0x1000,%rcx
	subq	%rax,%rcx
	subq	%rcx,%rdi
	movq	%rdi,%rsp
	shrq	$3, %rcx
	rep movsq
	jmp	*%rdx

#define	HYPERNAMES \
		set_trap_table \
		,mmu_update \
		,set_gdt \
		,stack_switch \
		,set_callbacks \
		,fpu_taskswitch \
		,sched_op_compat \
		,platform_op \
		,set_debugreg \
		,get_debugreg \
		,update_descriptor \
		,memory_op \
		,unknown0 \
		,multicall \
		,update_va_mapping \
		,set_timer_op \
		,event_channel_op_compat \
		,xen_version \
		,console_io \
		,physdev_op_compat \
		,grant_table_op \
		,vm_assist \
		,update_va_mapping_otherdomain \
		,iret \
		,vcpu_op \
		,set_segment_base \
		,mmuext_op \
		,xsm_op \
		,nmi_op \
		,sched_op \
		,callback_op \
		,xenoprof_op \
		,event_channel_op \
		,physdev_op \
		,hvm_op \
		,sysctl \
		,domctl \
		,kexec_op \
		,tmem_op \
		,fill_0 \
		,fill_1 \
		,fill_2 \
		,fill_3 \
		,fill_4 \
		,fill_5 \
		,fill_6 \
		,fill_7 \
		,fill_8 \
		,arch_0 \
		,arch_1 \
		,arch_2 \
		,arch_3 \
		,arch_4 \
		,arch_5 \
		,arch_6 \
		,arch_7

/*
 * No idea what they were smoking, but somehow they managed to mangle
 * the order of the arguments when calling into the hypervisor.
 *
 * XXX Should we restrict this prolog to only hypercalls with at least
 * XXX three arguments?
 */
	.irp	name, HYPERNAMES
	.globl	hypercall_\name
hypercall_\name:
	movq	%rcx, %r10
	jmp	__hyper_\name
	.endr

	.globl	hypercallpage
	.org	0x1000
hypercallpage:
	.irp	name, HYPERNAMES
__hyper_\name:
	.skip	0x20
	.endr
	.org	hypercallpage+0x1000

XEN_NOTE(XEN_ELFNOTE_XEN_VERSION, .asciz "xen-3.0")
XEN_NOTE(XEN_ELFNOTE_LOADER, .asciz "generic")
XEN_NOTE(XEN_ELFNOTE_VIRT_BASE, .quad VIRT_BASE)
XEN_NOTE(XEN_ELFNOTE_PADDR_OFFSET, .quad VIRT_BASE)
