#ifndef	__ATOMIC_H__
#define	__ATOMIC_H__

/*
 * While the intent for the first argument to these *_ptr functions
 * is meant to be "volatile void **", that would lead to a warning
 * "dereferencing type-punned pointer will break strict-aliasing rules",
 * so leave it at "volatile void *".
 */
extern void *atomic_cas_ptr(volatile void *, void *, void *);
extern void *atomic_swap_ptr(volatile void *, void *);

extern unsigned int atomic_cas_32(volatile unsigned int *,
				   unsigned int, unsigned int);

extern void atomic_add_64(volatile unsigned long *, long);
extern void atomic_and_64(volatile unsigned long *, unsigned long);
extern unsigned long atomic_cas_64(volatile unsigned long *,
				   unsigned long, unsigned long);
extern void atomic_dec_64(volatile unsigned long *);
extern void atomic_inc_64(volatile unsigned long *);
extern unsigned long atomic_swap_64(volatile unsigned long *, unsigned long);

#endif
