/*
 * Copyright (c) 2011 Wolfgang Solfrank.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the  
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Wolfgang Solfrank.
 * 4. The name of TooLs GmbH may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TOOLS GMBH ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL TOOLS GMBH BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef	__NOTE_H__
#define	__NOTE_H__

#include <elfnote.h>

#ifdef	__ASSEMBLY__
#define	XEN_NOTE(tag, value)				\
	.section	".note.Xen","",@note;		\
	.p2align	2;				\
	.long		4;				\
	.long		2f-1f;				\
	.long		tag;				\
	.asciz		"Xen";				\
1:	value;						\
2:							\
	.p2align	2
#else
#define	__S(x)	#x
#define	XEN_NOTE(tag, value)				\
	asm(".section \".note.Xen\", \"\",@note");	\
	asm(".p2align 2");				\
	asm(".long 4");					\
	asm(".long 2f - 1f");				\
	asm(".long " __S(tag));				\
	asm(".asciz \"Xen\"");				\
	asm("1:");					\
	asm(value);					\
	asm("2:");					\
	asm(".p2align 2");				\
	asm(".text");
#endif

#endif
